﻿"use strict";

// TODO - CLEAN UP; ENTIRE FILE IS TRIAGE

var GameElements = GameElements || {}

GameElements.i_round;
GameElements.i_delay = 120;

GameElements.fu_LoadContent = function () {

    // LOAD THE LOGO
    GameElements.Logo = new Logo();
    GameElements.Logo.fu_LoadContent();

    // LOAD THE PLAYER CHARACTER
    GameElements.Player = new Player();
    GameElements.Player.fu_LoadContent();

    // LOAD CATS
    GameElements.CatManager = new CatManager();
    GameElements.CatManager.fu_LoadContent();

}

GameElements.fu_Initialize = function () {

    // INITIALIZE LOGO
    GameElements.Logo.fu_Initialize();

    // INITIALIZE CATS
    GameElements.CatManager.fu_Initialize();

    // INITIALIZE OTHER ELEMENTS
    GameElements.fu_ReInitialize();

}

GameElements.fu_Update = function () {


    // TODO - USE FOR PAUSE
    if (GameLoop.s_state == "running") {

        // UPDATE PLAYER
        GameElements.Player.fu_Update();

        // UPDATE KITTIES
        GameElements.CatManager.fu_Update();

    } else if (GameLoop.s_state == "count") {

    } else if (GameLoop.s_state == "start") {

        // UPDATE LOGO
        GameElements.Logo.fu_Update();

        GameElements.i_delay--;
        if (GameElements.i_delay <= 0) {

            // CHANGE STATE
            GameLoop.fu_SetState("running");

            // SET LOGO INVISIBLE
            GameElements.Logo.b_visible = false;

            // SET PLAYER VISIBLE
            GameElements.Player.b_visible = true;
        }

    } else if (GameLoop.s_state == "over") {
        
    } else if (GameLoop.s_state == "win") {
    
        GameElements.i_round++;
        GameElements.fu_ReStart();
        GameLoop.fu_SetState("count");
    }

}

GameElements.fu_Draw = function () {

    // CLEAR THE CANVAS
    context.globalAlpha = 1;
    context.fillStyle = GameColor.Clone(GameColor.BLACK).ToRGB();
    context.fillRect(0, 0, canvas.width, canvas.height);

    GameElements.Logo.fu_Draw();
    GameElements.CatManager.fu_Draw();
    GameElements.Player.fu_Draw();
}

// RE INITIALIZE ONLY THE ELEMENTS NEEDED TO RESTART THE GAME
GameElements.fu_ReInitialize = function () {

    GameElements.Player.fu_Initialize();

    GameElements.CatManager.fu_Initialize();

    // CALL RESTART
//    GameElements.fu_ReStart();

    // INITIALIZE UI SYSTEM
//    UI.fu_Initialize();
//    if (GameConstants.B_DEBUG) { console.log('UI Initialized'); }

//    GameElements.i_round = 1;
}